using System;

class Program {
    static void Main() {
     
        int N = int.Parse(Console.ReadLine());  
        int[] A = Array.ConvertAll(Console.ReadLine().Split(), int.Parse); 
        int[] B = Array.ConvertAll(Console.ReadLine().Split(), int.Parse);  


        long maxValue = 0;

     
        for (int L = 0; L < N; L++) {
            int xorValue = 0;
            int andValue = (1 << 30) - 1; 

            for (int R = L; R < N; R++) {
             
                xorValue ^= A[R]; 
                andValue &= B[R];  
        
                long currentValue = (long)xorValue * andValue;
                maxValue = Math.Max(maxValue, currentValue);
            }
        }

        Console.WriteLine(maxValue);
    }
}